import { Ref, RefTypes } from './ref';
export interface Queue<K, T extends object> {
    queue(item: T): Ref<K>;
    numUnprocessed(): number;
    drain(cb: (ref: Ref<K>, item: T) => void): {
        processedCount: number;
    };
    drainUntilEmpty(cb: (ref: Ref<K>, item: T) => void): {
        processedCount: number;
    };
}
export declare function createQueue<RefRegistry, K extends RefTypes<RefRegistry>, T extends object, IDInfo = string, OtherInfo = undefined>(k: K, getIdInfo: (t: T) => IDInfo, extractId?: (info: IDInfo) => {
    id: string;
    otherInfo?: OtherInfo;
}): Queue<K, T>;
//# sourceMappingURL=queue.d.ts.map